/*
 * fmsn
 * Copyright (C) 2003  Choiday
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * Choiday
 * day@smileday.net
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif
#define GROUP
#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "login.h"
#include "network.h"
#include "mainview.h"
#include "global.h"
#include "session.h"

/*
 * Main Window
 */
#ifdef GROUP 
void
on_mainwindow_destroy                  (GtkObject       *object,
                                        gpointer         user_data)
{
	gtk_main_quit();
}


void
on_login1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	loginwindow = create_loginwindow ();
	gtk_widget_show (loginwindow);
}


void
on_logout1_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	GtkWidget *fixed1;
	GtkWidget *Clicktologin;
	//GError *error = NULL;

	Send(main_channel, "OUT\n");
	/*
	g_io_channel_shutdown (main_channel, TRUE, &error);
	if (error != NULL) {
		g_print("error channel shutdown : %s\n", error->message);
		g_error_free(error);
		return;
	}
	*/
		
	gtk_widget_destroy(main_viewport);
	main_viewport = gtk_viewport_new (NULL, NULL);
	gtk_widget_show (main_viewport);
	gtk_container_add (GTK_CONTAINER (scrolledwindow3), main_viewport);
	
	fixed1 = gtk_fixed_new ();
	gtk_widget_show (fixed1);
	gtk_container_add (GTK_CONTAINER (main_viewport), fixed1);
	
	Clicktologin = gtk_button_new_with_mnemonic (_("Click to login"));
	gtk_widget_show (Clicktologin);
	gtk_fixed_put (GTK_FIXED (fixed1), Clicktologin, 80, 56);
	gtk_widget_set_usize (Clicktologin, 176, 40);
	gtk_container_set_border_width (GTK_CONTAINER (Clicktologin), 2);
	
	gtk_signal_connect (GTK_OBJECT (Clicktologin), "clicked",
                      GTK_SIGNAL_FUNC (on_Clicktologin_clicked),
                      NULL);
}


void
on_online1_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	if(	mystatus != NLN )
	{
		mystatus = NLN;
		Send(main_channel, "CHG 3 NLN 0\r\n");
	}
}


void
on_busy1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	if(	mystatus != BSY )
	{
		mystatus = BSY;
		Send(main_channel, "CHG 3 BSY 0\r\n");
	}
}


void
on_i_ll_be_back1_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	if(	mystatus != IDL )
	{
		mystatus = IDL;
		Send(main_channel, "CHG 3 IDL 0\r\n");
	}
}


void
on_away1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	if(	mystatus != AWY )
	{
		mystatus = AWY;
		Send(main_channel, "CHG 3 AWY 0\r\n");
	}

}


void
on_phone1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	if(	mystatus != PHN )
	{
		mystatus = PHN;
		Send(main_channel, "CHG 3 PHN 0\r\n");
	}
}


void
on_eat_something1_activate             (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	if(	mystatus != LUN )
	{
		mystatus = LUN;
		Send(main_channel, "CHG 3 LUN 0\r\n");
	}
}


void
on_offline1_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	if(	mystatus != FLN )
	{
		mystatus = FLN;
		Send(main_channel, "CHG 3 HDN 0\r\n");
	}
}


void
on_hotmail1_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_send_a_file1_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_open_the_file1_activate             (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on___________q_1_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	gtk_main_quit();
}


void
on______________t_1_activate           (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on________c_1_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_______________p_1_activate          (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_add_a_friend1_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_find_some_friends1_activate         (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_advanced_search1_activate           (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_search_by1_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_manage_friends1_activate            (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_delete_friends1_activate            (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_view_profile1_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_preference1_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_manage_groups1_activate             (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_add_group1_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_delete_group1_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_rename_group1_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_sort_by1_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_group1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_online_offline1_activate            (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_regroup_offline1_activate           (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_option1_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_about1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	about_me();
}


void
on_Clicktologin_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
	loginwindow = create_loginwindow ();
	gtk_widget_show (loginwindow);
}
#endif
/*
 * Login Window
 */
#ifdef GROUP
void
on_loginwindow_destroy                 (GtkObject       *object,
                                        gpointer         user_data)
{
	gtk_widget_destroy(GTK_WIDGET(object));
}


void
on_password_activate                   (GtkEntry        *entry,
                                        gpointer         user_data)
{
	GError *error;
	sock = login();

	main_channel = g_io_channel_unix_new(sock);
	
	g_io_channel_set_encoding(main_channel, NULL, &error);
     if(error) {
	     g_print("Error channel encoding: %s.\n", error->message);
          g_error_free(error);
          return;
     }
	
	main_channel->is_seekable = 0;
    g_io_channel_set_buffered(main_channel, FALSE);

	g_io_add_watch(main_channel, G_IO_IN | G_IO_PRI, Async_receive, NULL);
	g_io_channel_unref(main_channel);
		
	Send(main_channel, "URL 5 INBOX\n");
	Send(main_channel, "CHG 6 NLN\n");
	Send(main_channel, "BLP 7 AL\n"); // i don't know what this mean.
/*	
	sock = login();
	fcntl(sock, F_SETFL, O_NONBLOCK); 
	maintag = gdk_input_add(sock, GDK_INPUT_READ, (GdkInputFunction) Async_receive, NULL);
	
	Socket_send(sock, "URL 5 INBOX\n");
	Socket_send(sock, "CHG 6 NLN\n");
	Socket_send(sock, "BLP 7 AL\n");
*/
}


void
on_checkbutton1_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

}


void
on_login_button_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
	GError *error;
	sock = login();

	main_channel = g_io_channel_unix_new(sock);
	
	g_io_channel_set_encoding(main_channel, NULL, &error);
     if(error) {
	     g_print("Error channel encoding: %s.\n", error->message);
          g_error_free(error);
          return;
     }
	
	main_channel->is_seekable = 0;
    g_io_channel_set_buffered(main_channel, FALSE);

	g_io_add_watch(main_channel, G_IO_IN | G_IO_PRI, Async_receive, NULL);
	g_io_channel_unref(main_channel);
		
	Send(main_channel, "URL 5 INBOX\n");
	Send(main_channel, "CHG 6 NLN\n");
	Send(main_channel, "BLP 7 AL\n"); // i don't know what this mean.
/*	
	sock = login();
	fcntl(sock, F_SETFL, O_NONBLOCK); 
	maintag = gdk_input_add(sock, GDK_INPUT_READ, (GdkInputFunction) Async_receive, NULL);
	
	Socket_send(sock, "URL 5 INBOX\n");
	Socket_send(sock, "CHG 6 NLN\n");
	Socket_send(sock, "BLP 7 AL\n");
*/
}
#endif

/*
 * Chat Window
 */
#ifdef GROUP
void
on_chatwindow_destroy                  (GtkObject       *object,
                                        gpointer         user_data)
{
	GIOChannel *channel;
		
	GtkWidget *session = lookup_widget(GTK_WIDGET(object), "session");
	channel = chat_session_get_channel(CHAT_SESSION(session));
	
	Send(channel,"OUT\r\n");
	willbedestroyed = 1;
}


void
on________s_1_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on____________________________a_1_activate
                                        (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on___________q_2_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on______________t_2_activate           (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on________c_2_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_______________p_2_activate          (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_block1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_view_profile2_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_invite1_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_send_a_file2_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_send_a_mail1_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_about3_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_sendfilebutton_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_invitebutton_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_blockbutton_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_fontbutton_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_smilebutton_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{

}

void
on_chatentry_changed                      (GtkEditable     *editable,
                                        gpointer         user_data)
{
    static gint sended;
    GtkWidget *session = lookup_widget(GTK_WIDGET(editable), "session");
	GIOChannel *channel;
    
	channel = chat_session_get_channel(CHAT_SESSION(session));
    
	if(chat_session_get_member(CHAT_SESSION(session)) > 0) {
		sended = 0;
        //Send(channel,"MSG 6 N %d\r\nMIME-Version: 1.0\r\nContent-Type: text/x-msmsgscontrol\r\nTypingUser: %s\r\n\r\n\r\n",   73+strlen(id), id);
	}
	else if (sended == 0) {
		GtkWidget *window = lookup_widget(GTK_WIDGET(editable), "chatwindow");
		Send(channel, "CAL 2 %s\r\n", gtk_window_get_title(GTK_WINDOW(window)));
		sended = 1;
    }
}

void
on_chatentry_activate                  (GtkEntry        *entry,
                                        gpointer         user_data)
{
	gint len;
	gchar *temp;
	gchar message[300];
	GIOChannel *channel;
	GtkTextBuffer *buffer;
	GtkTextIter start, end;
  	GtkTextMark *mark;
	GtkWidget *textview = lookup_widget(GTK_WIDGET(entry), "chat_textview");
	GtkWidget *session = lookup_widget(GTK_WIDGET(entry), "session");
	
	channel = chat_session_get_channel(CHAT_SESSION(session));
	
	buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(textview));
	
	gtk_text_buffer_get_bounds (buffer, &start, &end);
	mark = gtk_text_buffer_create_mark (buffer, NULL, &end, /* right grav */ FALSE);
	
	
		
	temp = g_strdup(gtk_entry_get_text(entry));
	sprintf(message, "\n%s :\n", nickname);			
	gtk_text_buffer_insert(buffer, &end, message,-1);
	sprintf(message, "%s\n", temp);
	gtk_text_buffer_insert(buffer, &end, temp ,-1);
		
	gtk_text_view_scroll_to_mark (GTK_TEXT_VIEW (textview), mark,
								0, TRUE, 0.0, 1.0);
	gtk_text_buffer_delete_mark (buffer, mark);
	
	len = strlen(temp)+116;
		  
	//Send(channel,"MSG 6 N %d\r\nMIME-Version: 1.0\r\nContent-Type: text/x-msmsgscontrol\r\nTypingUser: %s\r\n\r\n\r\n",	73+strlen(id), id);
	Send(channel,"MSG 1 N %d\r\nMIME-Version: 1.0\r\nContent-Type: text/plain; charset=UTF-8\r\nX-MMS-IM-Format: FN=Sans; EF=; C0=000000; CS=0; PF=0\r\n\r\n%s", len, temp);
	gtk_entry_set_text(entry,"");
		
	g_free(temp);	

}


void
on_sendbutton_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{

}

#endif


/* 
 * MainView Window
 */
#ifdef GROUP
void on_row_activated (GtkTreeView *tree_view, GtkTreePath *path, GtkTreeViewColumn *column)
{
	gint buddystatus;
	gtk_tree_model_get_iter(GTK_TREE_MODEL(tree), &now_iter, path);
	gtk_tree_model_get (GTK_TREE_MODEL(tree), &now_iter,
						BUDDYSTATUS, &buddystatus,
						-1);
    if (buddystatus != FLN) {
		Send(main_channel, "XFR 7 SB\r\n");
	}
}
#endif
