/*
 * fmsn
 * Copyright (C) 2003  Choiday
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * Choiday
 * day@smileday.net
 */

#include <gtk/gtk.h>
#include "network.h"
#include "mainstream.h"
#include "mainview.h"
#include "support.h"
#include "global.h"
#include "chatstream.h"
#include "session.h"

gboolean
Chat_receive(GIOChannel *chan, GIOCondition condition, gpointer data)
{
	gchar *buffer;
	guint len;
	
	GError *error=NULL;
	
	buffer = (gchar *)alloca(sizeof(gchar) * MAXRECV);
    memset(buffer, '\0', sizeof(gchar) * MAXRECV);
	
	g_io_channel_read_chars(chan, buffer, MAXRECV, &len, &error);
	
	if(error != NULL) 
	{
		g_print("Could not read from channel in chat session: %s.\n", error->message);
		g_error_free(error);
		gtk_main_quit();
	}
	
	if (len <= 0) 
	{
		g_print("Could not read from channel in chat session.may be this means end.\n");
		GError *error = NULL;

		g_io_channel_shutdown (chan, TRUE, &error);
		if (error != NULL) {
			g_print("error channel shutdown : %s\n", error->message);
			g_error_free(error);
		}
		if ( willbedestroyed == 0) {
			gtk_widget_destroy(GTK_WIDGET(data));
		}
		willbedestroyed = 0;
		return FALSE;
	}
	else 
	{
		Parse_chat_command(chan, buffer, GTK_WIDGET(data));
	}
	
	return TRUE;
}

void Parse_chat_command(GIOChannel *chan, gchar *buffer, GtkWidget *window) 
{
	GtkWidget *textview;
	GtkWidget *session;
	GtkTextBuffer *buf;
	GtkTextIter start, end;
  	GtkTextMark *mark;
	
	g_print("chat : \n%s\n",buffer);
	
	session = lookup_widget(GTK_WIDGET(window), "session");	
	
	if(!strncmp(buffer, "MSG", 3)) {
		gchar *mes;
		
		mes = (gchar *)alloca(MAXRECV);
		textview = lookup_widget(GTK_WIDGET(window), "chat_textview");	
		buf = gtk_text_view_get_buffer(GTK_TEXT_VIEW(textview));
		gtk_text_buffer_get_bounds (buf, &start, &end);
		mark = gtk_text_buffer_create_mark (buf, NULL, &end, /* right grav */ FALSE);
		
		mes = strrchr(buffer, '\n');
		mes++;
		
		gtk_text_buffer_insert(buf, &end, "\nreceived:\n",-1);
		gtk_text_buffer_insert(buf, &end, mes ,-1);
		
		gtk_text_view_scroll_to_mark (GTK_TEXT_VIEW (textview), mark,
                                0, TRUE, 0.0, 1.0);
  		gtk_text_buffer_delete_mark (buf, mark);
	}
	if(!strncmp(buffer, "IRO", 3)) {
		chat_session_add_member(CHAT_SESSION(session));
	}
	if(!strncmp(buffer, "BYE", 3)) {
		chat_session_remove_member(CHAT_SESSION(session));
	}
	if(!strncmp(buffer, "JOI", 3)) {
		chat_session_add_member(CHAT_SESSION(session));
	}
}
