/*
 * fmsn
 * Copyright (C) 2003  Choiday
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * Choiday
 * day@smileday.net
 */

#include <gtk/gtk.h>
#include "mainstream.h"
#include "network.h"
#include "mainview.h"
#include "support.h"
#include "md5.h"
#include "global.h"
#include "chatstream.h"
#include "interface.h"

gboolean
Async_receive(GIOChannel *chan, GIOCondition condition, gpointer data)
{
	gchar *buffer;
	static gchar forw[MAXRECV];
	gchar *rest;	
	guint len;
	gchar buf[MAXRECV];
	gchar *tok;
	
	GError *error=NULL;
	
	buffer = (gchar *)alloca(sizeof(gchar) * MAXRECV);
    memset(buffer, '\0', sizeof(gchar) * MAXRECV);
	rest = (gchar *)alloca(sizeof(gchar) * MAXRECV);
	tok = (gchar *)alloca(sizeof(gchar) * MAXRECV);
	
	g_io_channel_read_chars(chan, buffer, MAXRECV, &len, &error);
	if(error != NULL) 
	{
		g_print("Could not read from channel : %s.\n", error->message);
		g_error_free(error);
		gtk_main_quit();
	}
	
	if (len <= 0) 
	{
		g_io_channel_shutdown (chan, TRUE, &error);
		if(error != NULL) 
		{
			g_error_free(error);
		}
		g_print("Could not read from channel.\n");
		gtk_main_quit();
	}
	else 
	{
		strcat(forw, buffer); 
	
		rest = strrchr(forw,'\n');
		rest++;
				
		if (*rest != '\0') {
			strcpy(buf, forw);
			buf[rest - forw] = '\0';
						
			tok = strtok(buf, "\r\n");
			Parse_command(chan, tok);
			while( (tok = strtok(NULL, "\r\n")) != NULL )
			{
				Parse_command(chan, tok);
			}
			
			strcpy(forw, rest);
		}
		else {
			tok = strtok(forw, "\r\n");
			Parse_command(chan, tok);
			while( (tok = strtok(NULL, "\r\n")) != NULL )
			{
				Parse_command(chan, tok);
			}
			strcpy(forw,"");
		}
	}
	return TRUE;
	
}

void Parse_command(GIOChannel *chan, gchar *buffer)
{
	g_print("main : \n%s\n",buffer);
	if(!strncmp(buffer, "FLN", 3)) {
		GSList *searched;
		gchar email_id[MAXID];
		gchar *where;
		
		sscanf(buffer, "%*s %s", email_id);
		Find_iter_from_id(email_id);
		
		where =  gtk_tree_model_get_string_from_iter(GTK_TREE_MODEL(tree), &buddy_iter);		
		searched = g_slist_find_custom(on, where, Compare_value);
		
		g_free(where);
		
		g_print("found : %s\n", (char *)searched->data);

        on = g_slist_remove_link (on, searched);
        off = g_slist_concat(off, searched);
	
		print_list();
		
		gtk_tree_store_set (tree, &buddy_iter, 
							ICON, image[FLN], 
							BUDDYSTATUS, FLN, 
							-1);
	}
	if(!strncmp(buffer, "NLN", 3)) {
		GSList *searched;
		gchar status[4];
		gchar email_id[MAXID];
		gchar *where;
						
		sscanf(buffer, "%*s %s %s %*s", status, email_id);
		Find_iter_from_id(email_id);
		
		where =  gtk_tree_model_get_string_from_iter(GTK_TREE_MODEL(tree), &buddy_iter);		
		searched = g_slist_find_custom(off, where, Compare_value);
		g_free(where);
		if (searched != NULL) { //if offline -> online
			g_print("found : %s\n", (char *)searched->data);
	
			off = g_slist_remove_link (off, searched);
			on = g_slist_concat(on, searched);
			
			print_list();
		}
			
		if(!strncmp(status, "NLN", 3)) {
			gtk_tree_store_set (tree, &buddy_iter, 
							ICON, image[NLN], 
							BUDDYSTATUS, NLN, //online later fix! 
							-1);
		}
		if(!strncmp(status, "IDL", 3)) {
			gtk_tree_store_set (tree, &buddy_iter, 
							ICON, image[IDL], 
							BUDDYSTATUS, IDL, //idle later fix! 
							-1);
		}
		if(!strncmp(status, "BSY", 3)) {
			gtk_tree_store_set (tree, &buddy_iter, 
							ICON, image[BSY], 
							BUDDYSTATUS, BSY, //idle later fix! 
							-1);
		}
		if(!strncmp(status, "AWY", 3)) {
			gtk_tree_store_set (tree, &buddy_iter, 
							ICON, image[AWY], 
							BUDDYSTATUS, AWY, //idle later fix! 
							-1);
		}
		if(!strncmp(status, "PHN", 3)) {
			gtk_tree_store_set (tree, &buddy_iter, 
							ICON, image[PHN], 
							BUDDYSTATUS, PHN, //idle later fix! 
							-1);
		}
		if(!strncmp(status, "LUN", 3)) {
			gtk_tree_store_set (tree, &buddy_iter, 
							ICON, image[LUN], 
							BUDDYSTATUS, LUN, //idle later fix! 
							-1);
		}
		if(!strncmp(status, "BRB", 3)) {
			gtk_tree_store_set (tree, &buddy_iter, 
							ICON, image[BRB], 
							BUDDYSTATUS, BRB, //idle later fix! 
							-1);
		}
		
	}
	if(!strncmp(buffer, "ILN", 3)) {
		GSList *searched;	
		gchar status[4];
		gchar email_id[MAXID];
		gchar *where;
		
		sscanf(buffer, "%*s %*d %s %s %*s", status, email_id);
		
		Find_iter_from_id(email_id);
		where =  gtk_tree_model_get_string_from_iter(GTK_TREE_MODEL(tree), &buddy_iter);		
		searched = g_slist_find_custom(off, where, Compare_value);
		g_free(where);
		if (searched != NULL) { //if offline -> online
			g_print("found : %s\n", (char *)searched->data);
	
			off = g_slist_remove_link (off, searched);
			on = g_slist_concat(on, searched);
			
			print_list();
		}
		
		if(!strncmp(status, "NLN", 3)) {
			gtk_tree_store_set (tree, &buddy_iter, 
							ICON, image[NLN], 
							BUDDYSTATUS, NLN, //online later fix! 
							-1);
		}
		if(!strncmp(status, "IDL", 3)) {
			gtk_tree_store_set (tree, &buddy_iter, 
							ICON, image[IDL], 
							BUDDYSTATUS, IDL, //idle later fix! 
							-1);
		}
		if(!strncmp(status, "BSY", 3)) {
			gtk_tree_store_set (tree, &buddy_iter, 
							ICON, image[BSY], 
							BUDDYSTATUS, BSY, //idle later fix! 
							-1);
		}
		if(!strncmp(status, "AWY", 3)) {
			gtk_tree_store_set (tree, &buddy_iter, 
							ICON, image[AWY], 
							BUDDYSTATUS, AWY, //idle later fix! 
							-1);
		}
		if(!strncmp(status, "PHN", 3)) {
			gtk_tree_store_set (tree, &buddy_iter, 
							ICON, image[PHN], 
							BUDDYSTATUS, PHN, //idle later fix! 
							-1);
		}
		if(!strncmp(status, "LUN", 3)) {
			gtk_tree_store_set (tree, &buddy_iter, 
							ICON, image[LUN], 
							BUDDYSTATUS, LUN, //idle later fix! 
							-1);
		}
		if(!strncmp(status, "BRB", 3)) {
			gtk_tree_store_set (tree, &buddy_iter, 
							ICON, image[BRB], 
							BUDDYSTATUS, BRB, //idle later fix! 
							-1);
		}
	}
	if(!strncmp(buffer, "RNG", 3)) {
		GtkWidget *chat;
		GError *error;
		GIOChannel *channel;
		
		gint s_sock;
		gchar ipAddress[16];
		gchar CKI[200];
		gint session_id;
		gint port;
		gchar email_id[MAXID];
		gchar nick[MAXNICKNAME];
				
		sscanf(buffer, "%*s %d %[^:]:%d %*s %s %s %s", \
					&session_id, ipAddress, &port, CKI, email_id, nick);
		
		strcpy(title,email_id);
		s_sock = Socket_connect(ipAddress, port);
		assert(s_sock);

		channel = g_io_channel_unix_new(s_sock);
		
		g_io_channel_set_encoding(channel, NULL, &error);
          if(error) {
	          g_print("Error channel encoding: %s.\n", error->message);
	          g_error_free(error);
	          return;
          }
		channel->is_seekable = 0;
		g_io_channel_set_buffered(channel, FALSE);
						
		/*TODO*/
		//
		//we need to check whether chatwindow is running or not!!!
		//
		
		chat = create_chatwindow(channel);
		gtk_widget_show (chat);		  
		g_io_add_watch(channel, G_IO_IN | G_IO_PRI, Chat_receive, chat);
		g_io_channel_unref(channel);
		
		Send(channel, "ANS 1 %s %s %d\r\n", id, CKI, session_id);
		
	}
	
	if(!strncmp(buffer, "XFR", 3)) {
		
		GtkWidget *chat;
		GError *error;
		GIOChannel *channel;				
		
		gchar *email_id;
		
		gint s_sock;
		gchar ipAddress[16];
		gchar CKI[200];
		gint port;
		
		gtk_tree_model_get (GTK_TREE_MODEL(tree), &now_iter,
						ID, &email_id,
						-1);
		strcpy(title, email_id);
		
		sscanf(buffer, "%*s %*s %*s %[^:]:%d %*s %s", ipAddress, &port, CKI);

		s_sock = Socket_connect(ipAddress, port);
		assert(s_sock);
		
		channel = g_io_channel_unix_new(s_sock);
		g_io_channel_set_encoding(channel, NULL, &error);
          if(error) {
	          g_print("Error channel encoding: %s.\n", error->message);
	          g_error_free(error);
	          return;
          }
		channel->is_seekable = 0;
		g_io_channel_set_buffered(channel, FALSE);
		
		chat = create_chatwindow(channel);
		gtk_widget_show (chat);
		
  	  	g_io_add_watch(channel, G_IO_IN | G_IO_PRI, Chat_receive, chat);
		g_io_channel_unref(channel);
				
		Send(channel, "USR 1 %s %s\n", id, CKI);
		Send(channel, "CAL 2 %s\n", email_id);	
		
		g_free(email_id);
		
  	}
	
	if(!strncmp(buffer, "LSG", 3)) //Group
	{
		gchar temp[MAXGROUPNAME];
		gint groupnum;
		gchar *url;

		sscanf(buffer, "%*s %*d %*d %*d %*d %d %s %*d", &groupnum, temp);

		url = url_decode(temp);
		Add_group(url, groupnum);
		g_free(url);
	}
	
	if(!strncmp(buffer, "LST", 3)) //buddy
	{
		gchar ID[MAXID];
		gchar nickname[MAXNICKNAME];
		gchar spec[3];
		gint type=0;
		gint groupnum;
		gchar *url;
		
		sscanf(buffer, "%*s %*d %s %*d %*d %*d %s %s %d", spec, ID, nickname, &groupnum); 
		
		// set type of buddy list by 
		if(!strncmp(spec,"BL",2)) type += BL;	//  BL = 0001 
		if(!strncmp(spec,"AL",2)) type += AL;	//  AL = 0010
		if(!strncmp(spec,"RL",2)) type += RL;	//  RL = 0100
		if(!strncmp(spec,"FL",2)) {
			type += FL;	//  FL = 1000
			url = url_decode(nickname);
			Add_buddy(url, groupnum, type, ID);
			g_free(url);
		}
		
		// HAVE TO DO
		// save AL if we need it later
	}
	
	if(!strncmp(buffer, "CHL", 3)) //challenge 
	{
		md5_state_t state;
		md5_byte_t digest[16];
		gchar hash[200];
		gchar temp[200];
		gint i;
		
		sscanf(buffer, "%*s %d %s", &tr_id, hash);
		
		md5_init(&state);
		md5_append(&state, (const md5_byte_t *)hash, strlen(hash));
		md5_append(&state, (const md5_byte_t *)"Q1P7W2E4J9R8U3S5", strlen("Q1P7W2E4J9R8U3S5"));
		md5_finish(&state, digest);
		
		for (i = 0; i < 16; ++i) {
			if(i == 0)
				sprintf(temp, "%02x", digest[i]);
			else
				sprintf(temp, "%s%02x", temp, digest[i]);
		}
		Send(chan, "QRY %d msmsgs@msnmsgr.com 32\r\n%s", tr_id, temp);
	}	
}
