/*
 * fmsn
 * Copyright (C) 2003  Choiday
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * Choiday
 * day@smileday.net
 */

#include <gtk/gtk.h>
#include "mainview.h"
#include "login.h"
#include "support.h"
#include "global.h"
#include "interface.h"
#include "network.h"
#include "chatstream.h"
#include "callbacks.h"

void Init_mainview()
{
	
	/* destroy loginwindow and login button */
	gtk_widget_destroy(main_viewport);
	gtk_widget_destroy(loginwindow);
	
	/* make buddy tree view */
	tree = gtk_tree_store_new (N_COLUMNS,
							   GDK_TYPE_PIXBUF,
                	           G_TYPE_STRING, //nickname
                    		   G_TYPE_STRING, //ID
                               G_TYPE_INT, //group num
							   G_TYPE_INT, //buddy type
							   G_TYPE_INT); //buddy status
	main_viewport = gtk_tree_view_new_with_model (GTK_TREE_MODEL (tree));
	gtk_tree_view_set_headers_visible(GTK_TREE_VIEW(main_viewport), FALSE);
	
	column = gtk_tree_view_column_new();
	renderer = gtk_cell_renderer_pixbuf_new(); 
	gtk_tree_view_column_pack_start( column, renderer, FALSE);
	gtk_tree_view_column_set_attributes( column, renderer,
										"pixbuf", ICON,
										NULL);
	g_object_set(renderer, "xalign", 0.0, "ypad", 0, NULL);
	renderer = gtk_cell_renderer_text_new();
	gtk_tree_view_column_pack_start( column, renderer, TRUE);
	gtk_tree_view_column_set_attributes( column, renderer,
										"text", NICKNAME,
										NULL);
	g_object_set(renderer, "ypad", 0, "yalign", 0.5, NULL);
	gtk_tree_view_append_column (GTK_TREE_VIEW (main_viewport), column);
	
	gtk_widget_show(main_viewport);
	gtk_container_add (GTK_CONTAINER (scrolledwindow3), main_viewport);
	
	g_signal_connect(main_viewport, "row_activated",
                 G_CALLBACK(on_row_activated),
                 GTK_TREE_MODEL(tree));
	GLADE_HOOKUP_OBJECT (mainwindow, main_viewport, "main_viewport");
	image[FLN] = create_pixbuf("yami-25.ico");
	image[NLN] = create_pixbuf("icon_maro_12.ico");
	image[IDL] = create_pixbuf("icon_maro_05.ico");
	image[BSY] = create_pixbuf("yami-21.ico");
	image[AWY] = create_pixbuf("yami-20.ico");
	image[PHN] = create_pixbuf("yami-48.ico");
	image[LUN] = create_pixbuf("yami-33.ico");
	image[BRB] = create_pixbuf("yami-31.ico");
	mystatus = NLN;
}

void Add_group(gchar *name, gint groupnum)
{
	gchar text[MAXGROUPNAME];
	sprintf(text, "%s", name);	

	gtk_tree_store_append (tree, &group_iter, NULL);
	gtk_tree_store_set (tree, &group_iter,
					NICKNAME, text,
					GROUPNUMBER, groupnum,
					-1);
}	

void Add_buddy(gchar *nick,gint groupnum,gint type,gchar *email_id)
{
	gchar *where;
	gint nth = -1;
		
	gtk_tree_model_get_iter_first(GTK_TREE_MODEL(tree), &group_iter);
	
	gtk_tree_model_get (GTK_TREE_MODEL(tree), &group_iter, 
						GROUPNUMBER, &nth, 
						-1);
	while (groupnum != nth) {	
		gtk_tree_model_iter_next (GTK_TREE_MODEL(tree), &group_iter);
		gtk_tree_model_get (GTK_TREE_MODEL(tree), &group_iter, 
						GROUPNUMBER, &nth, 
						-1);
	} 

	gtk_tree_store_append (tree, &buddy_iter, &group_iter);
	gtk_tree_store_set (tree, &buddy_iter, 
						ICON, image[FLN], 
						NICKNAME, nick, 
						ID, email_id, 
						GROUPNUMBER, groupnum, 
						BUDDYTYPE, type, 
						BUDDYSTATUS, 0, 
						-1);
	
	//add offline list
	where = gtk_tree_model_get_string_from_iter(GTK_TREE_MODEL(tree), &buddy_iter);
	off = g_slist_prepend(off, where);
}
