/*
 * fmsn
 * Copyright (C) 2003  Choiday
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * Choiday
 * day@smileday.net
 */
 
#include <gtk/gtkmain.h>
#include <gtk/gtksignal.h>

#include "session.h"

/* Forward declarations */

static void chat_session_class_init               (ChatSessionClass    *klass);
static void chat_session_init                     (ChatSession         *session);
static void chat_session_destroy                  (GtkObject        *object);

/* Local data */

static GtkWidgetClass *parent_class = NULL;

GType
chat_session_get_type ()
{
  static GType session_type = 0;

  if (!session_type)
    {
      static const GTypeInfo session_info =
      {
	sizeof (ChatSessionClass),
	NULL,
	NULL,
	(GClassInitFunc) chat_session_class_init,
	NULL,
	NULL,
	sizeof (ChatSession),
        0,
	(GInstanceInitFunc) chat_session_init,
      };

      session_type = g_type_register_static (GTK_TYPE_WIDGET, "ChatSession", &session_info, 0);
    }

  return session_type;
}

static void
chat_session_class_init (ChatSessionClass *class)
{
  GtkObjectClass *object_class;
  GtkWidgetClass *widget_class;

  object_class = (GtkObjectClass*) class;
  widget_class = (GtkWidgetClass*) class;

  parent_class = gtk_type_class (gtk_widget_get_type ());

  object_class->destroy = chat_session_destroy;
}

static void
chat_session_init (ChatSession *session)
{
	session->member = 0;
}

gint		chat_session_get_member(ChatSession *session)
{
	return session->member;
}
gint		chat_session_remove_member(ChatSession *session)
{
	return --session->member;
}
gint		chat_session_add_member(ChatSession *session)
{
	return ++session->member;
}

GIOChannel*
chat_session_get_channel(ChatSession *session)
{
	GIOChannel *temp;
	temp = session->channel;
	return temp;
}

void
chat_session_set_channel(ChatSession *session, GIOChannel *channel)
{
	session->channel = channel;
}

GtkWidget*
chat_session_new ()
{
  ChatSession *session;

  session = g_object_new (chat_session_get_type (), NULL);
  return GTK_WIDGET (session);
}

static void
chat_session_destroy (GtkObject *object)
{
  ChatSession *session;

  g_return_if_fail (object != NULL);
  g_return_if_fail (GTK_IS_SESSION (object));

  session = CHAT_SESSION (object);

  if (GTK_OBJECT_CLASS (parent_class)->destroy)
    (* GTK_OBJECT_CLASS (parent_class)->destroy) (object);
}
