/*
 * fmsn
 * Copyright (C) 2003  Choiday
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * Choiday
 * day@smileday.net
 */
 
#ifndef __CHAT_SESSION_H__
#define __CHAT_SESSION_H__


#include <gdk/gdk.h>
#include <gtk/gtkwidget.h>


#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


#define CHAT_SESSION(obj)          GTK_CHECK_CAST (obj, chat_session_get_type (), ChatSession)
#define CHAT_SESSION_CLASS(klass)  GTK_CHECK_CLASS_CAST (klass, chat_session_get_type (), ChatSessionClass)
#define GTK_IS_SESSION(obj)       GTK_CHECK_TYPE (obj, chat_session_get_type ())


typedef struct _ChatSession        ChatSession;
typedef struct _ChatSessionClass   ChatSessionClass;

struct _ChatSession
{
  	GtkWidget widget;

	GIOChannel *channel;
	gint member;
};

struct _ChatSessionClass
{
  GtkWidgetClass parent_class;
};

gint		chat_session_get_member(ChatSession *session);
gint		chat_session_remove_member(ChatSession *session);
gint		chat_session_add_member(ChatSession *session);

GIOChannel* chat_session_get_channel(ChatSession *session);
void		chat_session_set_channel(ChatSession *session, GIOChannel *channel);
GtkWidget*     chat_session_new                    ();
GtkType        chat_session_get_type               (void);
#ifdef __cplusplus
}
#endif /* __cplusplus */


#endif /* __chat_session_H__ */
