/*
 * fmsn
 * Copyright (C) 2003  Choiday
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * Choiday
 * day@smileday.net
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <gtk/gtk.h>

#include "support.h"
#include "global.h"

gint Compare_value(gconstpointer source, gconstpointer target) {
        if ( strcmp((char *)source, (char *)target) == 0)
                return 0;
        else return -1;
}

void print_list(void) {
        GSList *temp;
        temp = on;

        if (temp != NULL) {
                do {
                        g_print("on : %s\n", (char *)temp->data);
                }while( (temp = g_slist_next(temp)) != NULL);
        }

        temp = off;
        if (temp != NULL) {
                do {
                        g_print("off : %s\n", (char *)temp->data);
                }while( (temp = g_slist_next(temp)) != NULL);
        }
}

void Find_iter_from_id (char *email_id)
{
    GtkTreeIter root;
        
    char *recorded_id;
    
    gtk_tree_model_get_iter_first   (GTK_TREE_MODEL(tree), &root);
    
    for(;;) {
        int find = 1;
                        
        if (gtk_tree_model_iter_has_child(GTK_TREE_MODEL(tree), &root)) 
        {
            gtk_tree_model_iter_children(GTK_TREE_MODEL(tree), &buddy_iter, &root);
            gtk_tree_model_get (GTK_TREE_MODEL(tree), &buddy_iter,
                            ID, &recorded_id,
                            -1);
        
            while (strcmp(recorded_id, email_id) != 0) { //is not correct   
                g_free(recorded_id);
                        
                if (gtk_tree_model_iter_next (GTK_TREE_MODEL(tree), &buddy_iter) == FALSE) {
                    find = 0; 
                    break;
                }
                else {
                    gtk_tree_model_get (GTK_TREE_MODEL(tree), &buddy_iter,
                            ID, &recorded_id,
                            -1);
                }
            }
            if (find == 1) break;
        }
        
            
        if (gtk_tree_model_iter_next (GTK_TREE_MODEL(tree), &root) == FALSE) {
            g_print("got some error in network.c:173 cannot find group\n");
            break;
        }   
    }
    g_free(recorded_id);
    
}

gchar *url_decode(const gchar *msg)
{
        gchar *buf;
	    int i, j = 0;
	
		buf = (gchar *)g_malloc(sizeof(gchar) * MSN_BUF_LEN);

        bzero(buf, sizeof(buf));
        for (i = 0; i < strlen(msg); i++) {
                gchar hex[3];
                if (msg[i] != '%') {
                        buf[j++] = msg[i];
                        continue;
                }
                strncpy(hex, msg + ++i, 2); hex[2] = 0;
                
                i++; 
				
                buf[j++] = strtol(hex, NULL, 16);
        }
        buf[j] = 0;
		
		return buf;
}

gchar *url_encode(const gchar *msg)
{
        gchar *buf;
        int i, j = 0;

		buf = (gchar *)g_malloc(sizeof(gchar) * MSN_BUF_LEN);
	
        bzero(buf, sizeof(buf));
        for (i = 0; i < strlen(msg); i++) {
                if (isalnum(msg[i]))
                        buf[j++] = msg[i];
                else {
                        sprintf(buf + j, "%%%02x", (guchar)msg[i]);
                        j += 3;
                }
        }
        buf[j] = 0;
		
		return buf;
}

GtkWidget*
lookup_widget                          (GtkWidget       *widget,
                                        const gchar     *widget_name)
{
  GtkWidget *parent, *found_widget;

  for (;;)
    {
      if (GTK_IS_MENU (widget))
        parent = gtk_menu_get_attach_widget (GTK_MENU (widget));
      else
        parent = widget->parent;
      if (!parent)
        parent = gtk_object_get_data (GTK_OBJECT (widget), "GladeParentKey");
      if (parent == NULL)
        break;
      widget = parent;
    }

  found_widget = (GtkWidget*) gtk_object_get_data (GTK_OBJECT (widget),
                                                   widget_name);
  if (!found_widget)
    g_warning ("Widget not found: %s", widget_name);
  return found_widget;
}

static GList *pixmaps_directories = NULL;

/* Use this function to set the directory containing installed pixmaps. */
void
add_pixmap_directory                   (const gchar     *directory)
{
  pixmaps_directories = g_list_prepend (pixmaps_directories,
                                        g_strdup (directory));
}

/* This is an internally used function to find pixmap files. */
static gchar*
find_pixmap_file                       (const gchar     *filename)
{
  GList *elem;

  /* We step through each of the pixmaps directory to find it. */
  elem = pixmaps_directories;
  while (elem)
    {
      gchar *pathname = g_strdup_printf ("%s%s%s", (gchar*)elem->data,
                                         G_DIR_SEPARATOR_S, filename);
      if (g_file_test (pathname, G_FILE_TEST_EXISTS))
        return pathname;
      g_free (pathname);
      elem = elem->next;
    }
  return NULL;
}

/* This is an internally used function to create pixmaps. */
GtkWidget*
create_pixmap                          (GtkWidget       *widget,
                                        const gchar     *filename)
{
  gchar *pathname = NULL;
  GtkWidget *pixmap;

  if (!filename || !filename[0])
      return gtk_image_new ();

  pathname = find_pixmap_file (filename);

  if (!pathname)
    {
      g_warning (_("Couldn't find pixmap file: %s"), filename);
      return gtk_image_new ();
    }

  pixmap = gtk_image_new_from_file (pathname);
  g_free (pathname);
  return pixmap;
}

/* This is an internally used function to create pixmaps. */
GdkPixbuf*
create_pixbuf                          (const gchar     *filename)
{
  gchar *pathname = NULL;
  GdkPixbuf *pixbuf;
  GError *error = NULL;

  if (!filename || !filename[0])
      return NULL;

  pathname = find_pixmap_file (filename);

  if (!pathname)
    {
      g_warning (_("Couldn't find pixmap file: %s"), filename);
      return NULL;
    }

  pixbuf = gdk_pixbuf_new_from_file (pathname, &error);
  if (!pixbuf)
    {
      fprintf (stderr, "Failed to load pixbuf file: %s: %s\n",
               pathname, error->message);
      g_error_free (error);
    }
  g_free (pathname);
  return pixbuf;
}

/* This is used to set ATK action descriptions. */
void
glade_set_atk_action_description       (AtkAction       *action,
                                        const gchar     *action_name,
                                        const gchar     *description)
{
  gint n_actions, i;

  n_actions = atk_action_get_n_actions (action);
  for (i = 0; i < n_actions; i++)
    {
      if (!strcmp (atk_action_get_name (action, i), action_name))
        atk_action_set_description (action, i, description);
    }
}
